;****************************************************************************
;
;  scalar.nas
;
;  Create:  26.04.2001
;  Update:  02.09.2001
;  (C)      Marcel Mller
;
;****************************************************************************

        %include "nasm.h"

        segment_code

proc    scalar_3DNow_nasm
        global scalar_3DNow_nasm
%$d     equ     4
%$p     equ     8
%$q     equ     12
%$len   equ     16

        nop
        femms
        nop
        mov     ecx,[sp(%$len)]
        nop
        mov     eax,[sp(%$p)]
        nop
        mov     edx,[sp(%$q)]
        nop

; mm0 = sum 0   r[0..len-1] . k[0..len-1] | l[0..len-1] . k[0..len-1]
; mm1 = sum 1   r[0..len-1] . k[0..len-1] | l[0..len-1] . k[0..len-1]

        pxor    mm0,mm0            ; R0      | L0
        pxor    mm1,mm1            ; R1      | L1
        shr     ecx,3
        jz      .no1
                                   ;                    * = write
                                   ;                    + = read
                                   ;                    | = hold
                                   ;                    x = read, no longer needed

                                   ;                    mm2 3 4 5 6 7
.start1:pmov    mm2, qword [edx]   ; k1      | k0         *
        pmov    mm7, qword [eax]   ; r0      | l0         |         *
.loop1: pmov    mm3, mm2           ; k1      | k0         + *       |
        pmov    mm6, qword [eax+8] ; r1      | l1         | |     * |
        punpckldq mm2, mm2         ; k0      | k0         * |     | |
        pmov    mm4, qword [edx+8] ; k3      | k2         | | *   | |
        punpckhdq mm3, mm3         ; k1      | k1         | * |   | |
        pfmul   mm7, mm2           ; r0 * k0 | l0 * k0    + | |   | *
        pmov    mm5, mm4           ; k3      | k2         | | + * | |
        pfmul   mm2, mm6           ; r1 * k0 | l1 * k0    * | | | + |
        pfadd   mm0, mm7           ; R0 += 0 | L0 += 0    | | | | | x
        pfmul   mm6, mm3           ; r1 * k1 | l1 * k1    | + | | *
        pmov    mm7, qword [eax+16]; r2      | l2         | | | | | *
        pfadd   mm1, mm2           ; R1 += 0 | L1 += 0    x | | | | |
        punpckldq mm4, mm4         ; k2      | k2           | * | | |
        pfmul   mm3, mm7           ; r2 * k1 | l2 * k1      * | | | +
        pfadd   mm0, mm6           ; R0 += 1 | L0 += 1      | | | x |
        punpckhdq mm5, mm5         ; k3      | k3           | | *   |
        add     edx, byte 32       ;                        | | |   |
        pmov    mm6, qword [eax+24]; r3      | l3           | | | * |
        pfmul   mm7, mm4           ; r2 * k2 | l2 * k2      | + | | *
        pfadd   mm1, mm3           ; R1 += 1 | L1 += 1      x | | | |
        pmov    mm2, qword [edx-16]; k5      | k4         *   | | | |
        pfmul   mm4, mm6           ; r3 * k2 | l3 * k2    |   * | + |
        pfadd   mm0, mm7           ; R0 += 2 | L0 += 2    |   | | | x
        pmov    mm3, mm2           ; k5      | k4         + * | | |
        pmov    mm7, qword [eax+32]; r4      | l4         | | | | | *
        pfmul   mm6, mm5           ; r3 * k3 | l3 * k3    | | | + * |
        pfadd   mm1, mm4           ; R1 += 2 | L1 += 2    | | x | | |
        punpckldq mm2, mm2         ; k4      | k4         * |   | | |
        pfmul   mm5, mm7           ; r4 * k3 | l4 * k3    | |   * | +
        pfadd   mm0, mm6           ; R0 += 3 | L0 += 3    | |   | x |
        punpckhdq mm3, mm3         ; k5      | k5         | *   |   |
        pmov    mm6, qword [eax+40]; r5      | l5         | |   | * |
        pfmul   mm7, mm2           ; r4 * k4 | l4 * k4    + |   | | *
        pfadd   mm1, mm5           ; R1 += 3 | L1 *= 3    | |   x | |
        add     eax, byte 64       ;                      | |     | |
        pmov    mm4, qword [edx-8] ; k7      | k6         | | *   | |
        pfmul   mm2, mm6           ; r5 * k4 | l5 * k4    * | |   + |
        pfadd   mm0, mm7           ; R0 += 4 | L0 += 4    | | |   | x
        pmov    mm5, mm4           ; k7      | k6         | | + * |
        pfmul   mm6, mm3           ; r5 * k5 | l5 * k5    | + | | *
        pmov    mm7, qword [eax-16]; r6      | l6         | | | | | *
        pfadd   mm1, mm2           ; R1 += 4 | L1 += 4    x | | | | |
        pfadd   mm0, mm6           ; R0 += 5 | L0 += 5      | | | x |
        punpckldq mm4, mm4         ; k6      | k6           | * |   |
        pfmul   mm3, mm7           ; r6 * k5 | l6 * k5      * | |   +
        pmov    mm6, qword [eax-8] ; r7      | l7           | | | * |
        pfmul   mm7, mm4           ; r6 * k6 | l6 * k6      | + | | *
        pfadd   mm1, mm3           ; R1 += 5 | L1 += 5      x | | | |
        punpckhdq mm5, mm5         ; k7      | k7             | * | |
        pfadd   mm0, mm7           ; R0 += 6 | L0 += 6        | | | x
        pfmul   mm4, mm6           ; r7 * k6 | l7 * k6        * | +
        pmov    mm7, qword [eax]   ; r8      | l8             | | | *
        pfmul   mm6, mm5           ; r7 * k7 | l3 * k7        | + * |
        pfadd   mm1, mm4           ; R1 += 6 | L1 += 6        x | | |
        dec     ecx                ;                            | | |
        pfmul   mm5, mm7           ; r8 * k7 | l8 * k7          * | +
        pfadd   mm0, mm6           ; R0 += 7 | L0 += 7          | x |
        jz      .end1              ;                            |   |
        pmov    mm2, qword [edx]   ; k9      | k8         *     |   |
        pfadd   mm1, mm5           ; R1 += 7 | L1 *= 7    |     x   |
        jmp     .loop1

.end1:  pfadd   mm1, mm5           ; R1 += 7 | L1 *= 7          x

.no1:   mov     ecx, [sp(%$len)]
        and     ecx, byte 7
        jz      .no2
.loop2: movd    mm2, dword [edx]   ; 0       | k0         *
        pmov    mm6, qword [eax]   ; r0      | l0         |       *
        punpckldq mm2, mm2         ; k0      | k0         *       |
        add     edx, byte 4        ;                      |       |
        pmov    mm7, qword [eax+8] ; r1      | l1         |       | *
        pfmul   mm6, mm2           ; r0 * k0 | l0 * k0    +       * |
        add     eax, byte 8        ;                      |       | |
        pfmul   mm7, mm2           ; r1 * k0 | l1 * k0    x       | *
        pfadd   mm0, mm6           ; R0 += 0 | L0 += 0            x |
        dec     ecx                ;                                |
        pfadd   mm1, mm7           ; R1 += 0 | L1 += 0              x
        jnz     .loop2

.no2:   mov     eax, dword[sp(%$d)]
        pmov    [eax], mm0
        pmov    [eax+8], mm1
        femms

endproc

proc    scanbuf_MMX_nasm
%$d     equ     4
%$p     equ     8
%$q     equ     12
%$len   equ     16

endproc

; end of scalar.nas
